#!/bin/sh

LOOPMNT=/mnt/live/modules/
#LOOPMNT=/mnt

STACK=/mnt/tmp/stack
#STACK=/mnt/sda3/init/stack


PKG=$1
#PKG=loop

if [ ! -f $STACK/$PKG ]
then
	echo "activated $PKG at boot"
	exit 1
fi
for i in `cat $STACK/$PKG`
do
	DEST="/${i%/*}"
	OBJ=${i##*/}
	if [ -f $DEST/.act.new.$OBJ ]
	then
	# シンボリックリンク設定処理有り #
		if [ -h /$i ]
		then
		# 設定したシンボリックリンク有り #
			rm -fr /$i
			rm $DEST/.act.new.$OBJ
			if [ -e $DEST/.act.org.$OBJ ]
			then
			# 元実態が有りセーブされている #
				mv $DEST/.act.org.$OBJ /$i
			fi
			# 正常ケース #
			continue
		fi

		if [ ! -e /$i ]
		then
		# 不正ケース 1 #
		# 何も無い #
			rm $DEST/.act.new.$OBJ
			if [ -e $DEST/.act.org.$OBJ ]
			then
			# 元実態が有りセーブされている #
				mv $DEST/.act.org.$OBJ /$i
			fi
			continue
		fi
		
		# 不正ケース 2 #
		# 設定したシンボリックリンク以外の物が有り #
		if [ -e $DEST/.act.org.$OBJ ]
		then
		# 元実態が有りセーブされている #
			rm -fr /$i
			mv $DEST/.act.org.$OBJ /$i
		fi
		rm $DEST/.act.new.$OBJ
		continue
	fi

	# 不正ケース 3 #
	# シンボリックリンク設定処理無し #
	if [ -e $DEST/.act.org.$OBJ ]
	then
	# 元実態が有りセーブされている #
		rm -fr /$i
		mv $DEST/.act.org.$OBJ /$i
	fi
done

rm $STACK/$PKG
	
exit 0	

